package com.enx_plugin.enx_flutter_plugin;

import android.content.Context;
import android.view.ViewGroup;
import android.widget.FrameLayout;

import java.util.HashMap;
import java.util.Map;

import enx_rtc_android.Controller.EnxPlayerView;
import io.flutter.plugin.common.MessageCodec;
import io.flutter.plugin.platform.PlatformView;
import io.flutter.plugin.platform.PlatformViewFactory;

public class EnxPlayerViewFactory extends PlatformViewFactory {
    private final EnxFlutterPlugin mFlutterPlugin;

    public EnxPlayerViewFactory(MessageCodec<Object> createArgsCodec, EnxFlutterPlugin enxFlutterPlugin) {
        super(createArgsCodec);
        this.mFlutterPlugin = enxFlutterPlugin;
    }

    /**
     * create method called while creating a new native view
     */
    @Override
    public PlatformView create(Context context, int id, Object o) {
        EnxPlayer rendererView = null;
        if(mFlutterPlugin.getView(id) == null){
            Map<String, Object> user = (Map<String, Object>)o;
            Map<String, Object> val = (Map<String, Object>)user.get("setZOrderMediaOverlay");

            EnxPlayerView playerView = new EnxPlayerView(mFlutterPlugin.mActivity, EnxPlayerView.ScalingType.SCALE_ASPECT_FILL,
                    (Boolean)val.get("mediaOverLay"));
            playerView.setLayoutParams(new FrameLayout.LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT, ViewGroup.LayoutParams.MATCH_PARENT));
             rendererView = new EnxPlayer(playerView, id);
            mFlutterPlugin.addView(playerView, id);

        }
        return rendererView;
    }
}